/*
 * Rogue: Exploring the Dungeons of Doom
 * Copyright (C) 1980-1983, 1985, 1999 Michael Toy, Ken Arnold and Glenn Wichman
 * All rights reserved.
 *
 * See the file LICENSE.TXT for full copyright and licensing information.
 *
 * @(#)main.c	4.22 (Berkeley) 02/05/99
 */

 //RJA adapted this from https://github.com/mikeyk730/Rogue-Collection/blob/master/readme.md







/* Updated by Rogue Central @ coredumpcentral.org on 2012-12-06.
 * Copyright (C) 2012 Rogue Central @ coredumpcentral.org. All Rights Reserved.
 * See README.CDC, LICENSE.CDC, and CHANGES.CDC for more information.
 */

#include "Platform.h"  //P2 Spin settings and such

#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include "curses.h"
#include "rogue.h"

//#define MASTER  //enable Wizard mode


typedef uint32_t chtype;
//#define msg printf
//#define addmsg printf
#define play_sound printf
#define ARMOR_DISPLAY(ac)             (10-(ac))
//void endmsg(void) {}

#include "extern.h"
#include "extern.c"
#include "rip.c"
#include "move.c"
#include "passages.c"
#include "potions.c"
#include "fight.c"
#include "daemon.c"
#include "daemons.c"
#include "io.c"
#include "chase.c"
#include "monsters.c"
#include "rooms.c"
#include "new_level.c"
#include "sticks.c"
#include "weapons.c"
#include "rings.c"
#include "things.c"
#include "misc.c"
#include "pack.c"
#include "list.c"
#include "init.c"
#include "vers.c"
#include "options.c"
#include "scrolls.c"
#include "armor.c"
#include "wizard.c"
#include "command.c"
#include "state.c"
#include "save.c"

#define BUFSIZ 512 //RJA

//1080p Screen parameters for tile driver
#define Cols  (120)       //characters are 16 pixels wide
#define Rows  (68)        //16 pixels tall   (two 16-pixel rows per character) (only 1/2 of last row visible)

int baudrate()
{//RJA
    return 2000;
}

WINDOW* tw, * sw;

/*
 * main:
 *	The main program, of course
 */
//int
//GAME_MAIN(int argc, char **argv)
void main()
{

    InitUserInterface(); //start P2 vga & mouse & files



    s_screen = 0; //DisplayInterface* s_screen = 0;
    s_input = 0; //InputInterface* s_input = 0;


    char *env;
    time_t lowtime;

    //printf("testing heap...\n");
    //for (int i = 0; i < 6000; i++)
    //{
    //    printf("%d:  Allocating 10kB...\n",i);
    //    char* c = mallocsafe(1024*30);
    //    c[1] = '9';
    //    printf("Allocating more!\n");
    //    char* d = mallocsafe(1024 * 30);
    //    d[2] = c[1];
    //    //printf("  Now, freeing...\n");
    //    //free(c);
    //}





    //md_init();

#ifdef MASTER
    /*
     * Check to see if he is a wizard
     */
    if (argc >= 2 && argv[1][0] == '\0')
	/*if (strcmp(PASSWD, md_crypt(md_getpass("wizard's password: "), "mT")) == 0) <-- Yet another RRFP replacement */
	if(passwd() == TRUE)
	{
	    wizard = TRUE;
	    player.t_flags |= SEEMONST;
	    argv++;
	    argc--;
	}

#endif

    /*
     * get home and options from environment
     */

//    /* Roguelike Restoration Project Fork: Changed rogue.save to rogue54.sav */
//    strcpy(home, md_gethomedir());
//
//	/*if (strlen(home) > MAXSTR - strlen("rogue.save") - 1)*/
//	if (strlen(home) > MAXSTR - strlen("rogue54.sav") - 1)
//		*home = 0;
//
//    strcpy(file_name, home);
//    /*strcat(file_name, "rogue.save");*/
//    strcat(file_name, "rogue54.sav");
//
//    if ((env = getenv("ROGUEOPTS")) != NULL)
//	parse_opts(env);
//    if (env == NULL || whoami[0] == '\0')
//        strucpy(whoami, md_getusername(), strlen(md_getusername()));
//    lowtime = time(NULL);
//    if (getenv("SEED") != NULL)
//    {
//	dnum = atoi(getenv("SEED"));
//#ifndef ROGUE_COLLECTION
//	noscore = 1;
//#endif
//    }
//    else
//	dnum = (unsigned int) lowtime + md_getpid();
//    seed = dnum;
    seed = _rnd();
//
//    open_score();
//
//	/* 
//     * Drop setuid/setgid after opening the scoreboard file. 
//     */ 
//
//    md_normaluser();
//
//    /*
//     * check for print-score option
//     */
//
//	md_normaluser(); /* we drop any setgid/setuid priveldges here */

 //   if (argc == 2)
 //   {
	//if (strcmp(argv[1], "-s") == 0)
	//{
	//    noscore = TRUE;
	//    score(0, -1, 0);
	//    exit(0);
	//}
	//else if (strcmp(argv[1], "-d") == 0)
	//{
	//    dnum = rnd(100);	/* throw away some rnd()s to break patterns */
	//    while (--dnum)
	//	rnd(100);
	//    purse = rnd(100) + 1;
	//    level = rnd(100) + 1;
	//    initscr();
	//    getltchars();
	//    death(death_monst());
	//    exit(0);
	//}
 //   }

//    init_check();			/* check for legal startup */
//    if (argc == 2)
//	if (!restore(argv[1]))	/* Note: restore will never return */
//	    my_exit(1);
//#ifdef MASTER
//    if (wizard)
//	printf("Hello %s, welcome to dungeon #%d\n", whoami, dnum);
//    else
//#endif
//	printf("Hello %s, just a moment while I dig the dungeon...\n", whoami);
//    fflush(stdout);



    printf("initscr\n");
    initscr();				/* Start up cursor package */



    printf("init_probs\n");
    init_probs();			/* Set up prob tables for objects */
    printf("init_player\n");
    init_player();			/* Set up initial player stats */
    printf("init_names\n");
    init_names();			/* Set up names of scrolls */
    printf("init_colors\n");
    init_colors();			/* Set up colors of potions */
    printf("init_stones\n");
    init_stones();			/* Set up stone settings of rings */
    printf("init_materials\n");
    init_materials();			/* Set up materials of wands */
    //setup();
    //PC_GFX_SETUP_COLORS();
    

    /*
     * The screen must be at least NUMLINES x NUMCOLS
     */
    if (LINES < NUMLINES || COLS < NUMCOLS)
    {
	printf("\nSorry, the screen must be at least %dx%d\n", NUMLINES, NUMCOLS);
	endwin();
	my_exit(1);
    }




    /*
     * Set up windows
     */
    hw = newwin(LINES, COLS, 0, 0);

    //RJA is reusing tw and sw instead of making new ones to avoid memory leak issue
    //So, created here once, to maximum size possible
    tw = newwin(LINES, COLS, 0, 0);
    sw = subwin(tw,LINES, COLS, 0, 0);



    //restore saved game?
    //printf("Load saved game? Press 'y' to load saved game from rogue1.dat\n");
    //if (getchar()=='y')
    //    restore("rogue1.dat");

    msg("Load saved game? Press 'y' to load saved game from rogue1.dat ");
    char c = MyGetCharSwitched();
    if ((c=='y')|| (c == 'Y'))
    { 
        msg("");//clear line
        msg("Loading...");
        restore("rogue1.dat");
    }


    //idlok(stdscr, TRUE);
    //idlok(hw, TRUE);
//#ifdef MASTER
//    noscore = wizard;
//#endif

      new_level();			/* Draw current level */
      //printf("parent1= %d", stdscr->parent);
      




//    /*
//     * Start up daemons and fuses
//     */
    start_daemon(runners, 0, AFTER);
    start_daemon(doctor, 0, AFTER);
    fuse(swander, 0, WANDERTIME, AFTER);
    start_daemon(stomach, 0, AFTER);


    playit();




//    return(0);
}

/*
 * endit:
 *	Exit the program abnormally.
 */

void
endit(int sig)
{
    NOOP(sig);
    fatal("Okay, bye bye!\n");
}

/*
 * fatal:
 *	Exit the program, printing a message.
 */

void
fatal(const char *s)
{
    mvaddstr(LINES - 2, 0, s);
    refresh();
    endwin();
    my_exit(0);
}

/*
 * rnd:
 *	Pick a very random number.
 */
int
rnd(int range)
{
    return range == 0 ? 0 : abs((int) RN) % range;
}

/*
 * roll:
 *	Roll a number of dice
 */
int 
roll(int number, int sides)
{
    int dtotal = 0;

    while (number--)
	dtotal += rnd(sides)+1;
    return dtotal;
}


/*
 * tstp:
 *	Handle stop and start signals
 */

void
tstp(int ignored)
{
    int y, x;
    int oy, ox;

	NOOP(ignored);

    /*
     * leave nicely
     */
    getyx(curscr, oy, ox);
    mvcur(0, COLS - 1, LINES - 1, 0);
    endwin();
    resetltchars();
    fflush(stdout);
	md_tstpsignal();

    /*
     * start back up again
     */
	md_tstpresume();
    raw();
    noecho();
    keypad(stdscr,1);
    playltchars();
    clearok(curscr, TRUE);
    wrefresh(curscr);
    getyx(curscr, y, x);
    mvcur(y, x, oy, ox);
    fflush(stdout);
    move(oy, ox);
    //curscr->_cury = oy;
    //curscr->_curx = ox;
}

/*
 * playit:
 *	The main loop of the program.  Loop until the game is over,
 *	refreshing things and looking at the proper times.
 */

void
playit(void)
{
    char *opts;

    /*
     * set up defaults for slow terminals
     */

    if (baudrate() <= 1200)
    {
	terse = TRUE;
	jump = TRUE;
	see_floor = FALSE;
    }

 //   if (md_hasclreol())
	//inv_type = INV_CLEAR;

 //   /*
 //    * parse environment declaration of options
 //    */
 //   if ((opts = getenv("ROGUEOPTS")) != NULL)
	//parse_opts(opts);


    oldpos = hero;
    oldrp = roomin(&hero);
    //EXITABLE(
    while (playing)
    {
        command();			/* Command execution */
    }
    //);
    //ENDIT(0);
}

/*
 * quit:
 *	Have player make certain, then exit.
 */

void
quit(int sig)
{
    int oy, ox;

    NOOP(sig);

    /*
     * Reset the signal in case we got here via an interrupt
     */
    if (!q_comm)
	mpos = 0;
    getyx(curscr, oy, ox);
    msg("really quit?");
    if (readchar() == 'y')
    {
	signal(SIGINT, leave);
	clear();
	//mvprintw(LINES - 2, 0, "You quit with %d gold pieces", purse);
	move(LINES - 1, 0);
	refresh();
	score(purse, 1, 0);
	my_exit(0);
    }
    else
    {
	move(0, 0);
	clrtoeol();
	status();
	move(oy, ox);
	refresh();
	mpos = 0;
	count = 0;
	to_death = FALSE;
    }
}

/*
 * leave:
 *	Leave quickly, but curteously
 */

void
leave(int sig)
{
 //   static char buf[BUFSIZ];

 //   NOOP(sig);

 //   setbuf(stdout, buf);	/* throw away pending output */

 //   if (!isendwin())
 //   {
	//mvcur(0, COLS - 1, LINES - 1, 0);
	//endwin();
 //   }

 //   putchar('\n');
 //   my_exit(0);
}

/*
 * shell:
 *	Let them escape for a while
 */

void
shell(void)
{
    /*
     * Set the terminal back to original mode
     */
    move(LINES-1, 0);
    refresh();
    endwin();
    resetltchars();
    putchar('\n');
    in_shell = TRUE;
    after = FALSE;
    fflush(stdout);
    /*
     * Fork and do a shell
     */
    md_shellescape();

    noecho();
    raw();
    keypad(stdscr,1);
    playltchars();
    in_shell = FALSE;
    clearok(stdscr, TRUE);
}

/*
 * my_exit:
 *	Leave the process properly
 */

void
my_exit(int st)
{
    //resetltchars();
    //EXIT(st);
}

